import React from 'react';
import { Link } from 'react-router';
import classNames from 'classnames';

let prefix = 'Blank--';
export default class Blank extends React.Component {

    showHref(type) {
        let buttonHref = '';

        switch(type) {
            case 'order':
                buttonHref = '/#';
                break;
            case 'schedule':
                buttonHref = '/#';
                break;
            case 'internet':
            default:
                buttonHref = 'javascript:;';
                break;
        }

        return buttonHref;
    }

    refresh(type, e) {
        if(!type || type == 'internet') {
            e.stopPropagation();
            e.preventDefault();
            location.reload();
        }
        return false;
    }

    showDesc(type) {
        let desc = '';

        switch(type) {
            case 'order':
                desc = '赶快去看场电影吧';
                break;
            case 'schedule':
                desc = '暂无排期';
                break;
            case 'internet':
            default:
                desc = '网络连接失败, 刷新试试';
                break;
        }
        return desc;
    }

    showButtonMsg(type) {
        let text = '';
        let btnClass = {
            type: 'primary',
            size: 'large-radius'
        };

        switch(type) {
            case 'order':
                text = '立即购票';
                btnClass = {
                    type: 'sell-inverse',
                    size: 'small'
                };
                break;
            case 'schedule':
                text = '返回首页';
                break;
            case 'internet':
            default:
                text = '刷新';
                break;
        }
        return { text, btnClass };
    }

    render() {
        const {
            type,
            className,
            children,
            value,
            href,
            ...others
        } = this.props;

        const classes = classNames({
            'Blank' : true,
            [prefix + type] : type,
            [className] : className
        });

        return (
            <div className={classes} {...others}>
                <p>{children || value || this.showDesc(type)}</p>
                <Link to={href || this.showHref(type)}>
                    <button {...this.showButtonMsg(type).btnClass} onClick={this.refresh.bind(this, type)}>
                        {this.showButtonMsg(type).text}
                    </button>
                </Link>
            </div>
        )
    }
}

Blank.propTypes = {
    type: React.PropTypes.string,
};
