import React, { PropTypes } from 'react';
import DatePicker from './DatePicker.js';

export default class ModalDatePicker extends React.Component {
    constructor(...args) {
        super(...args)
    }

    render() {
        return (
          <DatePicker {...this.props} />
        )
    }
}

ModalDatePicker.propTypes = {
    value: PropTypes.object,
    min: PropTypes.object,
    max: PropTypes.object,
    loopAdd: PropTypes.bool,
    showButton: PropTypes.bool,
    dateFormat: PropTypes.array,
    onSelect: PropTypes.func,
    onCancel: PropTypes.func,
};

ModalDatePicker.defaultProps = {
    value: new Date(),
    min: new Date(1970, 0, 1),
    max: new Date(2050, 0, 1),
    loopAdd: false,
    showButton: false,
    dateFormat: ['YYYY', 'M', 'D'],
    onSelect: () => {},
    onCancel: () => {},
    type: 'small',
};
