/**
 * @module DatePicker Component
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _DatePickerItemJs = require('./DatePickerItem.js');

var _DatePickerItemJs2 = _interopRequireDefault(_DatePickerItemJs);

var _pureRenderJs = require('./pureRender.js');

var _pureRenderJs2 = _interopRequireDefault(_pureRenderJs);

var _timeJs = require('./time.js');

/**
 * Class DatePicker Component Class
 * @extends Component
 */

var DatePicker = (function (_Component) {
    _inherits(DatePicker, _Component);

    function DatePicker(props) {
        _classCallCheck(this, DatePicker);

        _get(Object.getPrototypeOf(DatePicker.prototype), 'constructor', this).call(this, props);
        this.state = {
            value: (0, _timeJs.nextDate)(this.props.value)
        };

        this.handleFinishBtnClick = this.handleFinishBtnClick.bind(this);
        this.handleDateSelect = this.handleDateSelect.bind(this);
    }

    _createClass(DatePicker, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            // update value of state
            var date = (0, _timeJs.nextDate)(nextProps.value);
            if (date.getTime() !== this.state.value.getTime()) {
                this.setState({ value: date });
            }
        }

        /**
         * Optimization component, Prevents unnecessary rendering
         * Only props or state change or value before re-rendering
         *
         * @param  {Object} nextProps next props
         * @param  {Object} nextState next state
         * @return {Boolean}          Whether re-rendering
         */
    }, {
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps, nextState) {
            var date = (0, _timeJs.nextDate)(nextState.value);
            return date.getTime() !== this.state.value.getTime() || _pureRenderJs2['default'].shouldComponentUpdate(nextProps, nextState, this.props, this.state);
        }

        /**
         * 点击完成按钮事件
         * @return {undefined}
         */
    }, {
        key: 'handleFinishBtnClick',
        value: function handleFinishBtnClick() {
            this.props.onSelect(this.state.value);
        }

        /**
         * 选择下一个日期
         * @return {undefined}
         */
    }, {
        key: 'handleDateSelect',
        value: function handleDateSelect(value) {
            this.setState({ value: value });
            if (!this.props.showButton) {
                this.props.onSelect(this.state.value);
            }
        }

        /**
         * render函数
         * @return {Object} JSX对象
         */
    }, {
        key: 'render',
        value: function render() {
            var _props = this.props;
            var min = _props.min;
            var max = _props.max;
            var dateFormat = _props.dateFormat;
            var loopAdd = _props.loopAdd;
            var showButton = _props.showButton;
            var type = _props.type;

            var value = this.state.value;

            return _react2['default'].createElement(
                'div',
                {
                    className: 'datepicker' },
                _react2['default'].createElement(
                    'div',
                    { className: 'datepicker-content' },
                    _react2['default'].createElement(_DatePickerItemJs2['default'], {
                        value: value,
                        min: min,
                        max: max,
                        typeName: 'Year',
                        loopAdd: loopAdd,
                        format: dateFormat[0],
                        type: type,
                        onSelect: this.handleDateSelect }),
                    _react2['default'].createElement(_DatePickerItemJs2['default'], {
                        value: value,
                        min: min,
                        max: max,
                        typeName: 'Month',
                        loopAdd: loopAdd,
                        format: dateFormat[1],
                        type: type,
                        onSelect: this.handleDateSelect }),
                    _react2['default'].createElement(_DatePickerItemJs2['default'], {
                        value: value,
                        min: min,
                        max: max,
                        typeName: 'Date',
                        loopAdd: loopAdd,
                        format: dateFormat[2],
                        type: type,
                        onSelect: this.handleDateSelect })
                ),
                showButton ? _react2['default'].createElement(
                    'div',
                    { className: 'datepicker-navbar' },
                    _react2['default'].createElement(
                        'a',
                        {
                            className: 'datepicker-navbar-btn',
                            onClick: this.handleFinishBtnClick },
                        '完成'
                    ),
                    _react2['default'].createElement(
                        'a',
                        {
                            className: 'datepicker-navbar-btn',
                            onClick: this.props.onCancel },
                        '取消'
                    )
                ) : null
            );
        }
    }]);

    return DatePicker;
})(_react.Component);

DatePicker.propTypes = {
    value: _react.PropTypes.object,
    min: _react.PropTypes.object,
    max: _react.PropTypes.object,
    loopAdd: _react.PropTypes.bool,
    showButton: _react.PropTypes.bool,
    dateFormat: _react.PropTypes.array,
    onSelect: _react.PropTypes.func,
    onCancel: _react.PropTypes.func
};

exports['default'] = DatePicker;
module.exports = exports['default'];