
/**
 * @module Date组件
 */
'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i]; return arr2; } else { return Array.from(arr); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _timeJs = require('./time.js');

var TimeUtil = _interopRequireWildcard(_timeJs);

var _pureRenderJs = require('./pureRender.js');

var _transition = require('./transition');

var DATE_HEIGHT = 40; // 每个日期的高度
// const DATE_LENGTH = this.props.dateLength;            // 日期的个数
// const this.MIDDLE_INDEX = Math.floor(DATE_LENGTH / 2);     // 日期数组中间值的索引
// const this.MIDDLE_Y = - DATE_HEIGHT * this.MIDDLE_INDEX;       // translateY值

/**
 * Class Date组件类
 * @extends Component
 */

var DatePickerItem = (function (_Component) {
    _inherits(DatePickerItem, _Component);

    function DatePickerItem(props) {
        _classCallCheck(this, DatePickerItem);

        _get(Object.getPrototypeOf(DatePickerItem.prototype), 'constructor', this).call(this, props);
        this.animating = false; // 判断是否在transition过渡动画之中
        this.touchY = 0; // 保存touchstart的pageY
        this.translateY = 0; // 容器偏移的距离
        this.DATE_LENGTH = this.selectDiffType(); // 日期的个数
        this.MIDDLE_INDEX = Math.floor(this.DATE_LENGTH / 2); // 日期数组中间值的索引
        this.MIDDLE_Y = -DATE_HEIGHT * this.MIDDLE_INDEX; // translateY值
        this.currentIndex = this.MIDDLE_INDEX; // 滑动中当前日期的索引

        this.state = {
            translateY: this.MIDDLE_Y,
            marginTop: (this.currentIndex - this.MIDDLE_INDEX) * DATE_HEIGHT
        };

        this.renderDatepickerItem = this.renderDatepickerItem.bind(this);
        this.handleContentTouch = this.handleContentTouch.bind(this);
        this.handleContentMouseDown = this.handleContentMouseDown.bind(this);
        this.handleContentMouseMove = this.handleContentMouseMove.bind(this);
        this.handleContentMouseUp = this.handleContentMouseUp.bind(this);
    }

    _createClass(DatePickerItem, [{
        key: 'selectDiffType',
        value: function selectDiffType() {
            var type = this.props.type;

            switch (type) {
                case 'small':
                    return 3;
                case 'middle':
                    return 7;
                case 'large':
                    return 11;
                default:
                    return 3;
            }
        }
    }, {
        key: 'componentWillMount',
        value: function componentWillMount() {
            this._iniDates(this.props.value);
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (nextProps.value.getTime() === this.props.value.getTime()) {
                return;
            }
            this._iniDates(nextProps.value);
            this.currentIndex = this.MIDDLE_INDEX;
            this.setState({
                translateY: this.MIDDLE_Y,
                marginTop: (this.currentIndex - this.MIDDLE_INDEX) * DATE_HEIGHT
            });
        }

        /**
         * Optimization component, Prevents unnecessary rendering
         * Only value or state change should re-rendering
         *
         * @param  {Object} nextProps next props
         * @param  {Object} nextState next state
         * @return {Boolean}          Whether re-rendering
         */
    }, {
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps, nextState) {
            return nextProps.value.getTime() !== this.props.value.getTime() || !(0, _pureRenderJs.shallowEqual)(nextState, this.state);
        }
    }, {
        key: '_iniDates',
        value: function _iniDates(date) {
            var _this = this;

            var _props = this.props;
            var typeName = _props.typeName;
            var loopAdd = _props.loopAdd;

            var dates = Array.apply(undefined, _toConsumableArray(Array(this.DATE_LENGTH))).map(function (value, index) {
                return TimeUtil['next' + typeName](date, loopAdd, index - _this.MIDDLE_INDEX);
            });
            this.setState({ dates: dates });
        }
    }, {
        key: '_updateDates',
        value: function _updateDates(direction) {
            var _props2 = this.props;
            var typeName = _props2.typeName;
            var loopAdd = _props2.loopAdd;
            var dates = this.state.dates;

            if (direction === 1) {
                this.currentIndex++;
                this.setState({
                    dates: [].concat(_toConsumableArray(dates.slice(1)), [TimeUtil['next' + typeName](dates[dates.length - 1], loopAdd, 1)]),
                    marginTop: (this.currentIndex - this.MIDDLE_INDEX) * DATE_HEIGHT
                });
            } else {
                this.currentIndex--;
                this.setState({
                    dates: [TimeUtil['next' + typeName](dates[0], loopAdd, -1)].concat(_toConsumableArray(dates.slice(0, dates.length - 1))),
                    marginTop: (this.currentIndex - this.MIDDLE_INDEX) * DATE_HEIGHT
                });
            }
        }
    }, {
        key: '_checkIsUpdateDates',
        value: function _checkIsUpdateDates(direction, translateY) {
            return direction === 1 ? this.currentIndex * DATE_HEIGHT + DATE_HEIGHT / 2 < -translateY : this.currentIndex * DATE_HEIGHT - DATE_HEIGHT / 2 > -translateY;
        }

        /**
         * 清除对象的transition样式
         * @param  {Dom}     obj     指定的对象
         * @return {undefined}
         */
    }, {
        key: '_clearTransition',
        value: function _clearTransition(obj) {
            obj.style[_transition.TRANSITION] = ''; // eslint-disable-line
        }

        /**
         * 滑动到下一日期
         * @param  {number} direction 滑动方向
         * @return {undefined}
         */
    }, {
        key: '_moveToNext',
        value: function _moveToNext(direction) {
            var date = this.state.dates[this.MIDDLE_INDEX];
            var _props3 = this.props;
            var max = _props3.max;
            var min = _props3.min;

            if (direction === -1 && date.getTime() < min.getTime()) {
                this._updateDates(1);
            } else if (direction === 1 && date.getTime() > max.getTime()) {
                this._updateDates(-1);
            }

            this._moveTo(this.refs.scroll, this.currentIndex);
        }

        /**
         * 添加滑动动画
         * @param  {DOM} obj   DOM对象
         * @param  {number} angle 角度
         * @return {undefined}
         */
    }, {
        key: '_moveTo',
        value: function _moveTo(obj, currentIndex) {
            var _this2 = this;

            this.animating = true;
            obj.style[_transition.TRANSITION] = _transition.TRANSFORM_CSS + ' .2s ease-out'; // eslint-disable-line
            this.setState({
                translateY: -currentIndex * DATE_HEIGHT
            });
            setTimeout(function () {
                _this2.animating = false;
                _this2.props.onSelect(_this2.state.dates[_this2.MIDDLE_INDEX]);
                _this2._clearTransition(_this2.refs.scroll);
            }, 200);
        }
    }, {
        key: 'handleStart',
        value: function handleStart(event) {
            this.touchY = event.pageY || event.targetTouches[0].pageY;
            this.translateY = this.state.translateY;
        }
    }, {
        key: 'handleMove',
        value: function handleMove(event) {
            var touchY = event.pageY || event.targetTouches[0].pageY;
            var dir = touchY - this.touchY;
            var translateY = this.translateY + dir;
            var direction = dir > 0 ? -1 : 1;

            // 日期最小值，最大值限制
            var date = this.state.dates[this.MIDDLE_INDEX];
            var _props4 = this.props;
            var max = _props4.max;
            var min = _props4.min;

            if (date.getTime() < min.getTime() || date.getTime() > max.getTime()) {
                return;
            }

            // 检测是否更新日期列表
            if (this._checkIsUpdateDates(direction, translateY)) {
                this._updateDates(direction);
            }

            this.setState({ translateY: translateY });
        }
    }, {
        key: 'handleEnd',
        value: function handleEnd(event) {
            var touchY = event.pageY || event.changedTouches[0].pageY;
            var dir = touchY - this.touchY;
            var direction = dir > 0 ? -1 : 1;
            this._moveToNext(direction);
        }

        /**
         * 滑动日期选择器触屏事件
         * @param  {Object} event 事件对象
         * @return {undefined}
         */
    }, {
        key: 'handleContentTouch',
        value: function handleContentTouch(event) {
            event.preventDefault();
            if (this.animating) return;
            if (event.type === 'touchstart') {
                this.handleStart(event);
            } else if (event.type === 'touchmove') {
                this.handleMove(event);
            } else if (event.type === 'touchend') {
                this.handleEnd(event);
            }
        }

        /**
         * 滑动日期选择器鼠标事件
         * @param  {Object} event 事件对象
         * @return {undefined}
         */
    }, {
        key: 'handleContentMouseDown',
        value: function handleContentMouseDown(event) {
            if (this.animating) return;
            this.handleStart(event);
            document.addEventListener('mousemove', this.handleContentMouseMove);
            document.addEventListener('mouseup', this.handleContentMouseUp);
        }
    }, {
        key: 'handleContentMouseMove',
        value: function handleContentMouseMove(event) {
            if (this.animating) return;
            this.handleMove(event);
        }
    }, {
        key: 'handleContentMouseUp',
        value: function handleContentMouseUp(event) {
            if (this.animating) return;
            this.handleEnd(event);
            document.removeEventListener('mousemove', this.handleContentMouseMove);
            document.removeEventListener('mouseup', this.handleContentMouseUp);
        }

        /**
         * 渲染一个日期DOM对象
         * @param  {Object} date date数据
         * @return {Object}      JSX对象
         */
    }, {
        key: 'renderDatepickerItem',
        value: function renderDatepickerItem(date, index) {
            var typeName = this.props.typeName;
            var className = date < this.props.min || date > this.props.max ? 'disabled' : '';

            return _react2['default'].createElement(
                'li',
                {
                    key: index,
                    className: index == this.currentIndex ? 'current' : '' },
                TimeUtil.convertDate(date, this.props.format),
                typeName == 'Year' ? '年' : '',
                typeName == 'Month' ? '月' : '',
                typeName == 'Date' ? '日' : ''
            );
        }
    }, {
        key: 'render',
        value: function render() {
            var _scrollStyle;

            var scrollStyle = (_scrollStyle = {}, _defineProperty(_scrollStyle, _transition.TRANSFORM, 'translateY(' + this.state.translateY + 'px)'), _defineProperty(_scrollStyle, 'marginTop', this.state.marginTop), _scrollStyle);
            var type = this.props.type;

            return _react2['default'].createElement(
                'div',
                { className: 'datepicker-col-1' },
                _react2['default'].createElement(
                    'div',
                    {
                        className: 'datepicker-viewport ' + type,
                        onTouchStart: this.handleContentTouch,
                        onTouchMove: this.handleContentTouch,
                        onTouchEnd: this.handleContentTouch,
                        onMouseDown: this.handleContentMouseDown },
                    _react2['default'].createElement('div', { className: 'mask ' + type }),
                    _react2['default'].createElement(
                        'div',
                        { className: 'datepicker-wheel' },
                        _react2['default'].createElement(
                            'ul',
                            {
                                ref: 'scroll',
                                className: 'datepicker-scroll',
                                style: scrollStyle },
                            this.state.dates.map(this.renderDatepickerItem)
                        )
                    )
                )
            );
        }
    }]);

    return DatePickerItem;
})(_react.Component);

DatePickerItem.propTypes = {
    value: _react.PropTypes.object,
    min: _react.PropTypes.object,
    max: _react.PropTypes.object,
    format: _react.PropTypes.string,
    typeName: _react.PropTypes.string,
    onSelect: _react.PropTypes.func
};

exports['default'] = DatePickerItem;
module.exports = exports['default'];