'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames3 = require('classnames');

var _classnames4 = _interopRequireDefault(_classnames3);

var _reactDom = require('react-dom');

var prefix = 'Modal--';
var instances = [];

var Modal = (function (_Component) {
    _inherits(Modal, _Component);

    _createClass(Modal, null, [{
        key: 'propTypes',
        value: {
            className: _react.PropTypes.string,
            containerClassName: _react.PropTypes.string,
            animation: _react.PropTypes.string,
            disableAnimation: _react.PropTypes.bool,
            type: _react.PropTypes.oneOf(['default', 'small']),
            title: _react.PropTypes.string,
            okText: _react.PropTypes.string,
            cancelText: _react.PropTypes.string,
            onClose: _react.PropTypes.func,
            footer: _react.PropTypes.oneOfType([_react.PropTypes.node, _react.PropTypes.element]),
            header: _react.PropTypes.oneOfType([_react.PropTypes.node, _react.PropTypes.element]),
            backdropCloseable: _react.PropTypes.bool,
            backdropMoveable: _react.PropTypes.bool
        },
        enumerable: true
    }, {
        key: 'defaultProps',
        value: {
            animation: 'scaledown',
            backdropMoveable: false,
            backdropCloseable: false,
            disableAnimation: false,
            type: 'default',
            containerClassName: 'Modal__container',
            contentClassName: 'Modal__content'
        },
        enumerable: true
    }]);

    function Modal(args) {
        var _this = this;

        _classCallCheck(this, Modal);

        _get(Object.getPrototypeOf(Modal.prototype), 'constructor', this).call(this, args);

        this.onBackdropClick = function (e) {
            if (_this.props.backdropCloseable && e.target === _this.refs.modal) {
                _this.onClose();
            }
        };

        document.addEventListener('touchmove', this.globalTouchMoveHandler);
    }

    _createClass(Modal, [{
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            document.removeEventListener('touchmove', this.globalTouchMoveHandler);
        }
    }, {
        key: 'globalTouchMoveHandler',
        value: function globalTouchMoveHandler(e) {
            var target = e.target;

            // outside touch move should be prevented
            if ((target.classList.contains('.Modal__container') || target.querySelector('.Modal__container')) && !this.backdropMoveable) {
                e.preventDefault();
            }

            e.stopPropagation();
        }
    }, {
        key: 'onClose',
        value: function onClose(isOk) {
            if (this.props.onClose) {
                this.props.onClose(isOk);
            } else {
                Modal.close();
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _classnames, _classnames2;

            var _props = this.props;
            var className = _props.className;
            var containerClassName = _props.containerClassName;
            var children = _props.children;
            var type = _props.type;
            var title = _props.title;
            var header = _props.header;
            var footer = _props.footer;
            var okText = _props.okText;
            var cancelText = _props.cancelText;
            var animation = _props.animation;
            var disableAnimation = _props.disableAnimation;

            var others = _objectWithoutProperties(_props, ['className', 'containerClassName', 'children', 'type', 'title', 'header', 'footer', 'okText', 'cancelText', 'animation', 'disableAnimation']);

            animation = type === 'small' ? animation : 'slidedown';

            var classes = (0, _classnames4['default'])((_classnames = {
                'Modal_new': true
            }, _defineProperty(_classnames, className, className), _defineProperty(_classnames, 'Modal--small', type === 'small'), _classnames));

            var containerClass = (0, _classnames4['default'])((_classnames2 = {}, _defineProperty(_classnames2, containerClassName, true), _defineProperty(_classnames2, 'anim-' + animation, !disableAnimation), _defineProperty(_classnames2, containerClassName, containerClassName), _classnames2));

            var modalCount = instances.length;

            return _react2['default'].createElement(
                'div',
                _extends({}, others, {
                    className: classes,
                    style: { zIndex: 5000 + modalCount * 100 },
                    ref: 'modal',
                    onClick: this.onBackdropClick }),
                _react2['default'].createElement(
                    'style',
                    null,
                    'html {overflow: hidden;}'
                ),
                _react2['default'].createElement(
                    'div',
                    { className: containerClass, autoFocus: true },
                    title ? _react2['default'].createElement(
                        'div',
                        { className: 'Modal__header' },
                        _react2['default'].createElement(
                            'h3',
                            null,
                            ' ',
                            title,
                            ' '
                        ),
                        type !== 'small' && _react2['default'].createElement(
                            'span',
                            { className: 'Modal_new__close',
                                title: '关闭',
                                onClick: this.onClose.bind(this, false) },
                            '×'
                        )
                    ) : header,
                    _react2['default'].createElement(
                        'div',
                        { className: 'Modal__content', ref: 'modalContent' },
                        typeof children === 'string' ? _react2['default'].createElement(
                            'div',
                            { className: 'Modal__text' },
                            children,
                            ' '
                        ) : children
                    ),
                    footer === undefined ? _react2['default'].createElement(
                        'div',
                        { className: 'Modal__footer' },
                        !!cancelText && _react2['default'].createElement(
                            'span',
                            { className: 'Modal__btn',
                                onClick: this.onClose.bind(this, false) },
                            cancelText
                        ),
                        !!okText && _react2['default'].createElement(
                            'span',
                            { className: 'Modal__btn',
                                onClick: this.onClose.bind(this, true) },
                            okText
                        )
                    ) : footer
                )
            );
        }
    }]);

    return Modal;
})(_react.Component);

exports['default'] = Modal;

Modal.open = Modal.show = function (modal, id, keepAlive) {
    var target = document.createElement('div');
    keepAlive = typeof id === 'boolean' ? id : keepAlive;
    id = typeof id === 'boolean' ? Date.now() : id || Date.now();
    var target_id = 'vu-modal-' + id;
    instances.push({ id: id, keepAlive: keepAlive });
    target.id = target_id;
    document.body.appendChild(target);
    if (!_react2['default'].isValidElement(modal)) {
        modal = createModal(modal);
    }
    (0, _reactDom.render)(modal, target, function () {
        if (modal.props.disableAnimation) {
            document.body.classList.add('Modal--open');
        } else {
            setTimeout(function () {
                return document.body.classList.add('Modal--open');
            }, 10);
        }
    });
    console.dir(instances);
};

function createModal(props) {
    return _react2['default'].createElement(Modal, props);
}

Modal.close = Modal.hide = function (id) {
    if (instances.length > 0) {
        var _ret = (function () {
            if (id) {
                var i = -1;
                instances.forEach(function (item, index) {
                    if (item.id === id) i = index;
                });

                if (i !== -1) {
                    instances.splice(i, 1);
                } else {
                    console.log('id isn\'t right');
                    return {
                        v: undefined
                    };
                }
            }

            id = id || instances.pop().id;

            if (instances.length === 0) {
                document.body.classList && document.body.classList.remove('Modal--open');
            }

            var target_id = 'vu-modal-' + id;
            if (target_id) {
                setTimeout(function () {
                    var target = document.getElementById(target_id);
                    target && window.requestAnimationFrame(function () {
                        (0, _reactDom.unmountComponentAtNode)(target);
                        document.body.removeChild(target);
                    });
                }, 300);
            }
        })();

        if (typeof _ret === 'object') return _ret.v;
    }
};

Modal.closeAll = function () {
    instances.forEach(function (item) {
        if (!item.keepAlive) {
            Modal.close(item.id);
        }
    });
};

Modal.showAndHide = function (modal, id, time) {
    Modal.show(modal, id);
    setTimeout(function () {
        Modal.hide(id);
    }, time);
};
module.exports = exports['default'];