'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _visionUi = require('vision-ui');

var positionCache = {};

var ScrollPaging = (function (_React$Component) {
    _inherits(ScrollPaging, _React$Component);

    function ScrollPaging(props) {
        _classCallCheck(this, ScrollPaging);

        _get(Object.getPrototypeOf(ScrollPaging.prototype), 'constructor', this).call(this, props);
        this.locationHash = location.hash;
        this.scrollFunction = this.scrollListener.bind(this);
    }

    _createClass(ScrollPaging, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            var el = this._findElement();
            var name = this.locationHash;

            el.scrollTop = 0; // 为了避免即将上映未滚动情况下受到正在上映scrollTop影响

            if (positionCache[name] && this.props.retainPosition) {
                el.scrollTop = positionCache[name];
            }

            this.attachScrollListener();
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate(prevProps) {
            var el = this._findElement();
            var name = this.locationHash;

            this.attachScrollListener(prevProps);
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            this.detachScrollListener();
            this.retainPagePostion();
        }
    }, {
        key: '_findElement',
        value: function _findElement() {
            return this.props.parentNode || _reactDom2['default'].findDOMNode(this).parentNode;
        }
    }, {
        key: 'attachScrollListener',
        value: function attachScrollListener(prevProps) {
            if (!this.props.hasMore || this.props.loadingMore) return;
            var el = this._findElement();
            el.addEventListener('scroll', this.scrollFunction, true);
            el.addEventListener('resize', this.scrollFunction, true);
            this.scrollListener();
        }
    }, {
        key: 'retainPagePostion',
        value: function retainPagePostion() {
            var el = this._findElement();
            var name = this.locationHash;

            positionCache[name] = el.scrollTop;
        }
    }, {
        key: '_elScrollListener',
        value: function _elScrollListener() {
            var el = this._findElement();
            var topScrollPos = el.scrollTop;
            var totalContainerHeight = el.scrollHeight;
            var containerFixedHeight = el.offsetHeight;
            var bottomScrollPos = topScrollPos + containerFixedHeight;

            return totalContainerHeight - bottomScrollPos;
        }
    }, {
        key: 'scrollListener',
        value: function scrollListener() {
            // This is to prevent the upcoming logic from toggling a load more before
            // any data has been passed to the component
            if (this._totalItemsSize() <= 0) return;

            var bottomPosition = this._elScrollListener();

            if (this.props.auto && bottomPosition < Number(this.props.threshold)) {
                this.detachScrollListener();
                this.props.loadMore();
            }
        }
    }, {
        key: 'detachScrollListener',
        value: function detachScrollListener() {
            var el = this._findElement();
            el.removeEventListener('scroll', this.scrollFunction, true);
            el.removeEventListener('resize', this.scrollFunction, true);
        }
    }, {
        key: 'renderItems',
        value: function renderItems() {
            var allItems = this.props.children.concat(this.props.items);
            return allItems;
        }
    }, {
        key: 'renderAddition',
        value: function renderAddition() {
            return this.props.additionTemplate;
        }
    }, {
        key: '_totalItemsSize',
        value: function _totalItemsSize() {
            var totalSize = undefined;
            totalSize += this.props.children.length;
            totalSize += this.props.items.length;
            return totalSize;
        }
    }, {
        key: 'renderLoader',
        value: function renderLoader() {
            return this.props.hasMore && this.props.showLoader ? this.props.loader : undefined;
        }
    }, {
        key: '_assignHolderClass',
        value: function _assignHolderClass() {
            var additionalClass = undefined;
            additionalClass = typeof this.props.className === 'function' ? this.props.className() : this.props.className;

            return 'scroll-paging ' + additionalClass;
        }
    }, {
        key: 'loadManually',
        value: function loadManually() {
            this.props.loadMore();
        }
    }, {
        key: 'render',
        value: function render() {
            var Holder = this.props.holderType;

            return _react2['default'].createElement(
                Holder,
                { className: this._assignHolderClass() },
                this.renderItems(),
                _react2['default'].createElement(
                    'div',
                    { onClick: !this.props.auto && this.loadManually.bind(this) },
                    this.renderLoader()
                ),
                !this.props.hasMore ? this.renderAddition() : null
            );
        }
    }]);

    return ScrollPaging;
})(_react2['default'].Component);

exports['default'] = ScrollPaging;

ScrollPaging.propTypes = {
    additionTemplate: _react2['default'].PropTypes.any,
    threshold: _react2['default'].PropTypes.number,
    hasMore: _react2['default'].PropTypes.bool,
    loadingMore: _react2['default'].PropTypes.bool,
    auto: _react2['default'].PropTypes.bool,
    loader: _react2['default'].PropTypes.any,
    showLoader: _react2['default'].PropTypes.bool,
    retainPosition: _react2['default'].PropTypes.bool,
    loadMore: _react2['default'].PropTypes.func.isRequired,
    items: _react2['default'].PropTypes.oneOfType([_react2['default'].PropTypes.array]),
    children: _react2['default'].PropTypes.oneOfType([_react2['default'].PropTypes.array]),
    holderType: _react2['default'].PropTypes.string,
    className: _react2['default'].PropTypes.oneOfType([_react2['default'].PropTypes.string, _react2['default'].PropTypes.func])
};

ScrollPaging.defaultProps = {
    additionTemplate: null, // 没有更多时的展示模板
    auto: true, // 是否自动加载更多
    className: '',
    threshold: 100, // 单位px，距离底部多少时会触发loading
    hasMore: true, // 数据是否还有更多可以加载
    loadingMore: false, // 正在加载更多
    loader: _react2['default'].createElement(
        'div',
        { className: 'loading-more' },
        _react2['default'].createElement(_visionUi.Loading, { type: 'circle' })
    ), //加载中的模板
    showLoader: true, // 是否展示loader
    retainPosition: false, //返回上一页面回到原来位置
    holderType: 'div',
    children: [],
    items: []
};
module.exports = exports['default'];