'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x4, _x5, _x6) { var _again = true; _function: while (_again) { var object = _x4, property = _x5, receiver = _x6; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x4 = parent; _x5 = property; _x6 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var Swipeout = (function (_Component) {
    _inherits(Swipeout, _Component);

    _createClass(Swipeout, null, [{
        key: 'defaultProps',
        value: {
            btnWidth: 70, // 按钮宽度
            btnNum: 2,
            index: 0,
            classNames: '',
            hideCancelBtn: false,
            confirmText: '删除',
            cancelText: '取消',
            onDelOrder: function onDelOrder() {},
            onDelTransform: function onDelTransform() {}
        },
        enumerable: true
    }, {
        key: 'PropTypes',
        value: {
            btnWidth: Number,
            btnNum: Number,
            index: Number,
            classNames: String,
            confirmText: String,
            hideCancelBtn: Boolean,
            cancelText: String,
            onDelOrder: Function,
            onDelTransform: Function
        },
        enumerable: true
    }]);

    function Swipeout(props) {
        var _this = this;

        _classCallCheck(this, Swipeout);

        _get(Object.getPrototypeOf(Swipeout.prototype), 'constructor', this).call(this, props);

        this.onSwipeStart = function (e) {
            var _props = _this.props;
            var onDelTransform = _props.onDelTransform;
            var index = _props.index;

            onDelTransform(index);
            var touches = e.targetTouches && e.targetTouches[0] || e;
            _this.swipeInfo.startX = touches.pageX;
            _this.swipeInfo.startY = touches.pageY;
        };

        this.onSwipeMove = function (e) {
            var changeTouches = e.targetTouches && e.targetTouches[0] || e;
            var disY = changeTouches.pageY - _this.swipeInfo.startY;
            var disX = changeTouches.pageX - _this.swipeInfo.startX;
            // 滑动偏上或者滑动偏下，就禁止左右滑动
            _this.swipeInfo.direction = _this.swipeDirection(disY, disX);
            var _swipeInfo = _this.swipeInfo;
            var direction = _swipeInfo.direction;
            var swipeWith = _swipeInfo.swipeWith;

            if (direction === 'left' || direction === 'right') {
                e.preventDefault();
                e.stopPropagation();

                var translateX = _this.getTranslate();

                if (direction === 'left') {
                    if (translateX && translateX[0] <= -swipeWith) return;

                    var translateXDis = disX < -swipeWith ? -swipeWith : disX;

                    _this.swipeTransition(translateXDis);
                } else {
                    if (disX > swipeWith || !translateX || translateX[0] >= 0) return;

                    var translateXDis = -swipeWith + disX > 0 ? 0 : -swipeWith + disX;

                    _this.swipeTransition(translateXDis);
                }
            }
        };

        this.onSwipeEnd = function (e) {
            var endTouches = e.changedTouches && e.changedTouches[0] || e;
            var offX = endTouches.pageX - _this.swipeInfo.startX;
            var _swipeInfo2 = _this.swipeInfo;
            var direction = _swipeInfo2.direction;
            var swipeWith = _swipeInfo2.swipeWith;

            if (direction === 'left' && Math.abs(offX) > swipeWith / 3) {
                _this.swipeTransition(-swipeWith);
            } else if (offX !== 0) {
                _this.swipeTransition(0);
            }
        };

        this.onSwipeClick = function (e) {
            var translateX = _this.getTranslate();

            if (translateX && translateX[0] != '0') {
                e.preventDefault();
                e.stopPropagation();

                _this.swipeTransition(0);
            }
        };

        this.swipeInfo = {
            swipeWith: props.btnWidth * props.btnNum,
            startX: 0,
            startY: 0,
            direction: ''
        };
    }

    _createClass(Swipeout, [{
        key: 'swipeTransition',
        value: function swipeTransition() {
            var distance = arguments.length <= 0 || arguments[0] === undefined ? 0 : arguments[0];
            var time = arguments.length <= 1 || arguments[1] === undefined ? '.2s' : arguments[1];
            var fun = arguments.length <= 2 || arguments[2] === undefined ? 'linear' : arguments[2];

            var dom = this.refs.swipeItem;

            dom.style.webkitTransition = 'all ' + time + ' ' + fun;
            dom.style.webkitTransform = 'translate3d(' + distance + 'px, 0, 0)';
        }
    }, {
        key: 'swipeDirection',
        value: function swipeDirection(disY, disX) {
            // 滑动角度
            var r = Math.atan2(disY, disX);
            var swipeAngle = Math.round(r * 180 / Math.PI);

            if (swipeAngle < 0) {
                swipeAngle = 360 - Math.abs(swipeAngle);
            }

            switch (true) {
                case swipeAngle <= 210 && swipeAngle >= 150:
                    return 'left';
                case swipeAngle <= 30 || swipeAngle >= 330:
                    return 'right';
                case swipeAngle > 210 && swipeAngle < 330:
                    return 'up';
                case swipeAngle > 30 && swipeAngle < 150:
                    return 'down';
                default:
                    return 'left';
            }
        }
    }, {
        key: 'getTranslate',
        value: function getTranslate() {
            return this.refs.swipeItem.style.webkitTransform.match(/\-?\d+\.?\d+/);
        }
    }, {
        key: 'getSwipeEvents',
        value: function getSwipeEvents() {
            var swipeEvents = {
                onClick: this.onSwipeClick,
                onMouseDown: this.onSwipeStart,
                onMouseMove: this.onSwipeMove,
                onMouseUp: this.onSwipeEnd,
                onTouchStart: this.onSwipeStart,
                onTouchMove: this.onSwipeMove,
                onTouchEnd: this.onSwipeEnd
            };
            return swipeEvents;
        }
    }, {
        key: 'render',
        value: function render() {
            var _props2 = this.props;
            var onDelOrder = _props2.onDelOrder;
            var classNames = _props2.classNames;
            var btnWidth = _props2.btnWidth;
            var confirmText = _props2.confirmText;
            var cancelText = _props2.cancelText;
            var hideCancelBtn = _props2.hideCancelBtn;
            var children = _props2.children;

            return _react2['default'].createElement(
                'section',
                _extends({ className: 'swipe-item ' + classNames }, this.getSwipeEvents()),
                _react2['default'].createElement(
                    'div',
                    { className: 'swipe-item-ctn', ref: 'swipeItem' },
                    children
                ),
                _react2['default'].createElement(
                    'div',
                    { style: { width: btnWidth + 'px' }, className: 'swipe-item-btn confirm', onClick: onDelOrder },
                    confirmText
                ),
                !hideCancelBtn ? _react2['default'].createElement(
                    'div',
                    { style: { width: btnWidth + 'px' }, className: 'swipe-item-btn cancel' },
                    cancelText
                ) : null
            );
        }
    }]);

    return Swipeout;
})(_react.Component);

exports['default'] = Swipeout;
;
module.exports = exports['default'];